package cn.ibizlab.eam.core.po.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.eam.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.eam.core.po.domain.ENTITY2;
/**
 * 关系型数据实体[ENTITY2] 查询条件对象
 */
@Slf4j
@Data
public class ENTITY2SearchContext extends QueryWrapperContext<ENTITY2> {

	private String n_entity2name_like;//[实体2名称]
	public void setN_entity2name_like(String n_entity2name_like) {
        this.n_entity2name_like = n_entity2name_like;
        if(!ObjectUtils.isEmpty(this.n_entity2name_like)){
            this.getSearchCond().like("entity2name", n_entity2name_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("entity2name", query)   
            );
		 }
	}
}



