package cn.ibizlab.eam.core.po.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import cn.ibizlab.eam.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.eam.core.po.domain.THEUPDATE;
/**
 * 关系型数据实体[THEUPDATE] 查询条件对象
 */
@Slf4j
@Data
public class THEUPDATESearchContext extends QueryWrapperContext<THEUPDATE> {

	private String n_theupdatename_like;//[实体名称]
	public void setN_theupdatename_like(String n_theupdatename_like) {
        this.n_theupdatename_like = n_theupdatename_like;
        if(!ObjectUtils.isEmpty(this.n_theupdatename_like)){
            this.getSearchCond().like("theupdatename", n_theupdatename_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("theupdatename", query)   
            );
		 }
	}
}



