package cn.ibizlab.eam.core.po.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.eam.core.po.domain.ENTITY2;
import cn.ibizlab.eam.core.po.filter.ENTITY2SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface ENTITY2Mapper extends BaseMapper<ENTITY2>{

    Page<ENTITY2> searchDefault(IPage page, @Param("srf") ENTITY2SearchContext context, @Param("ew") Wrapper<ENTITY2> wrapper) ;
    @Override
    ENTITY2 selectById(Serializable id);
    @Override
    int insert(ENTITY2 entity);
    @Override
    int updateById(@Param(Constants.ENTITY) ENTITY2 entity);
    @Override
    int update(@Param(Constants.ENTITY) ENTITY2 entity, @Param("ew") Wrapper<ENTITY2> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

}
