package cn.ibizlab.eam.core.po.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.po.domain.ENTITY2;
import cn.ibizlab.eam.core.po.filter.ENTITY2SearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ENTITY2] 服务对象接口
 */
public interface IENTITY2Service extends IService<ENTITY2>{

    boolean create(ENTITY2 et) ;
    void createBatch(List<ENTITY2> list) ;
    boolean update(ENTITY2 et) ;
    void updateBatch(List<ENTITY2> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    ENTITY2 get(String key) ;
    ENTITY2 getDraft(ENTITY2 et) ;
    boolean checkKey(ENTITY2 et) ;
    boolean save(ENTITY2 et) ;
    void saveBatch(List<ENTITY2> list) ;
    Page<ENTITY2> searchDefault(ENTITY2SearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<ENTITY2> getEntity2ByIds(List<String> ids) ;
    List<ENTITY2> getEntity2ByEntities(List<ENTITY2> entities) ;
}


