package cn.ibizlab.eam.core.po.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.po.domain.THEUPDATE;
import cn.ibizlab.eam.core.po.filter.THEUPDATESearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[THEUPDATE] 服务对象接口
 */
public interface ITHEUPDATEService extends IService<THEUPDATE>{

    boolean create(THEUPDATE et) ;
    void createBatch(List<THEUPDATE> list) ;
    boolean update(THEUPDATE et) ;
    void updateBatch(List<THEUPDATE> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    THEUPDATE get(String key) ;
    THEUPDATE getDraft(THEUPDATE et) ;
    boolean checkKey(THEUPDATE et) ;
    boolean save(THEUPDATE et) ;
    void saveBatch(List<THEUPDATE> list) ;
    Page<THEUPDATE> searchDefault(THEUPDATESearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<THEUPDATE> getTheupdateByIds(List<String> ids) ;
    List<THEUPDATE> getTheupdateByEntities(List<THEUPDATE> entities) ;
}


