package cn.ibizlab.eam.core.po.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.eam.core.po.domain.ENTITY2;
import cn.ibizlab.eam.core.po.filter.ENTITY2SearchContext;
import cn.ibizlab.eam.core.po.service.IENTITY2Service;

import cn.ibizlab.eam.util.helper.CachedBeanCopier;
import cn.ibizlab.eam.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.eam.core.po.mapper.ENTITY2Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[实体2] 服务对象接口实现
 */
@Slf4j
@Service("ENTITY2ServiceImpl")
public class ENTITY2ServiceImpl extends ServiceImpl<ENTITY2Mapper, ENTITY2> implements IENTITY2Service {


    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(ENTITY2 et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getEntity2id()),et);
        return true;
    }

    @Override
    public void createBatch(List<ENTITY2> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(ENTITY2 et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("entity2id",et.getEntity2id())))
            return false;
        CachedBeanCopier.copy(get(et.getEntity2id()),et);
        return true;
    }

    @Override
    public void updateBatch(List<ENTITY2> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public ENTITY2 get(String key) {
        ENTITY2 et = getById(key);
        if(et==null){
            et=new ENTITY2();
            et.setEntity2id(key);
        }
        else{
        }
        return et;
    }

    @Override
    public ENTITY2 getDraft(ENTITY2 et) {
        return et;
    }

    @Override
    public boolean checkKey(ENTITY2 et) {
        return (!ObjectUtils.isEmpty(et.getEntity2id()))&&(!Objects.isNull(this.getById(et.getEntity2id())));
    }
    @Override
    @Transactional
    public boolean save(ENTITY2 et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(ENTITY2 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<ENTITY2> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<ENTITY2> list) {
        saveOrUpdateBatch(list,batchSize);
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<ENTITY2> searchDefault(ENTITY2SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<ENTITY2> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<ENTITY2>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<ENTITY2> getEntity2ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<ENTITY2> getEntity2ByEntities(List<ENTITY2> entities) {
        List ids =new ArrayList();
        for(ENTITY2 entity : entities){
            Serializable id=entity.getEntity2id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



